/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.Marshal
 *  com.locojoy.base.Marshal.OctetsStream
 *  com.locojoy.base.Octets
 *  cross.BroadcastData
 *  cross.CommonDataTransfer
 *  cross.SendUserInfoAndTicket
 *  fire.pb.game.STransferRoleTable
 *  fire.pb.game.STransferTable
 *  fire.pb.item.EquipItem
 *  fire.pb.item.GroceryItem
 *  fire.pb.item.ItemBase
 *  fire.pb.item.ItemMaps
 *  fire.pb.item.Module
 *  fire.pb.item.PetItem
 *  fire.pb.item.TaskItem
 *  fire.pb.item.TimeOutItem
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.GridPos
 *  fire.pb.map.Position
 *  fire.pb.util.FireProp
 *  fire.pb.util.OctetsUtil
 *  gnet.DeliveryManager
 *  gnet.link.Onlines
 *  mkdb.Bean
 *  mkdb.Executor
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.AUUserInfo
 *  xbean.CrossTempRole
 *  xbean.Equip
 *  xbean.Properties
 *  xtable.Auuserinfo
 *  xtable.Equips
 *  xtable.Properties
 */
package fire.pb.cross;

import com.locojoy.base.Marshal.Marshal;
import com.locojoy.base.Marshal.OctetsStream;
import com.locojoy.base.Octets;
import cross.BroadcastData;
import cross.CommonDataTransfer;
import cross.SendUserInfoAndTicket;
import fire.pb.cross.CheckCopyDataResultTask;
import fire.pb.cross.Constant;
import fire.pb.cross.Md5Util;
import fire.pb.cross.SBeginCorssServer;
import fire.pb.cross.SendRoleData;
import fire.pb.cross.TableData;
import fire.pb.cross.TransferDataManager;
import fire.pb.game.STransferRoleTable;
import fire.pb.game.STransferTable;
import fire.pb.item.EquipItem;
import fire.pb.item.GroceryItem;
import fire.pb.item.ItemBase;
import fire.pb.item.ItemMaps;
import fire.pb.item.Module;
import fire.pb.item.PetItem;
import fire.pb.item.TaskItem;
import fire.pb.item.TimeOutItem;
import fire.pb.main.ConfigManager;
import fire.pb.map.GridPos;
import fire.pb.map.Position;
import fire.pb.util.FireProp;
import fire.pb.util.OctetsUtil;
import gnet.DeliveryManager;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.TimeUnit;
import mkdb.Bean;
import mkdb.Executor;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.AUUserInfo;
import xbean.CrossTempRole;
import xbean.Equip;
import xtable.Auuserinfo;
import xtable.Equips;
import xtable.Properties;

public class CrossManager {
    public static Logger logger = Logger.getLogger((String)"SYSTEM");
    public static final String crossip = FireProp.getStringValue((String)"sys", (String)"sys.cross.ip");
    public static final int crossport = FireProp.getIntValue((String)"sys", (String)"sys.cross.startport");
    public static final int crossnum = FireProp.getIntValue((String)"sys", (String)"sys.cross.portnum");
    public Map<Integer, Long> transferingUsers = new ConcurrentHashMap<Integer, Long>(500);
    private Map<Long, String> userTickets = new HashMap<Long, String>();
    private Map<String, STransferTable> transferTableMap = new HashMap<String, STransferTable>();
    private Map<Integer, STransferRoleTable> transferRoleTableMap = new HashMap<Integer, STransferRoleTable>();

    public static CrossManager getInstance() {
        return SingletonHolder.singleton;
    }

    public long getTransferRoleByUserId(int userId) {
        if (!this.transferingUsers.containsKey(userId)) {
            return 0L;
        }
        return this.transferingUsers.get(userId);
    }

    public long removeTransferRoleByUserId(int userId) {
        return this.transferingUsers.remove(userId);
    }

    public STransferTable getSTransferTable(String tableName) {
        return this.transferTableMap.get(tableName);
    }

    public int getSTransferTableSize() {
        return this.transferRoleTableMap.size();
    }

    private CrossManager(Object o) {
        this.reload();
    }

    public void reload() {
        this.transferTableMap.clear();
        this.transferRoleTableMap.clear();
        TreeMap transfertablemap = ConfigManager.getInstance().getConf(STransferTable.class);
        if (transfertablemap == null) {
            throw new NullPointerException("Exception:STransferTable表配置有问题");
        }
        for (STransferTable tableInfo : transfertablemap.values()) {
            this.transferTableMap.put(tableInfo.getTableName(), tableInfo);
        }
        this.transferRoleTableMap = ConfigManager.getInstance().getConf(STransferRoleTable.class);
        if (this.transferRoleTableMap == null) {
            throw new NullPointerException("Exception:transferRoleTableMap表配置有问题");
        }
    }

    public boolean isInCrossServer() {
        return ConfigManager.getIsCrossServer();
    }

    public boolean sendToCrossServer(int dtype, Protocol protocol) {
        if (this.isInCrossServer()) {
            logger.info((Object)"跨服禁止调用sendToCrossServer！");
            return false;
        }
        CommonDataTransfer dataTransfer = new CommonDataTransfer();
        dataTransfer.flag = 1;
        dataTransfer.dtype = dtype;
        dataTransfer.content = new OctetsStream().marshal((Marshal)protocol);
        return DeliveryManager.getInstance().send((Protocol)dataTransfer);
    }

    public boolean sendToServerByServerId(int serverId, int dtype, Protocol protocol) {
        if (!this.isInCrossServer()) {
            logger.info((Object)"原服禁止调用sendToServerByServerId！");
            return false;
        }
        CommonDataTransfer dataTransfer = new CommonDataTransfer();
        dataTransfer.zoneid = serverId;
        dataTransfer.flag = (byte)2;
        dataTransfer.dtype = dtype;
        dataTransfer.content = new OctetsStream().marshal((Marshal)protocol);
        return DeliveryManager.getInstance().send((Protocol)dataTransfer);
    }

    public boolean broadcast(int dtype, Protocol protocol) {
        if (!this.isInCrossServer()) {
            logger.info((Object)"原服禁止调用sendToServerByServerId！");
            return false;
        }
        BroadcastData broadcast = new BroadcastData();
        broadcast.dtype = dtype;
        broadcast.content = new OctetsStream().marshal((Marshal)protocol);
        DeliveryManager.getInstance().send((Protocol)broadcast);
        return true;
    }

    public void beginCross(long roleId) {
        System.out.println(1111);
        if (this.isInCrossServer()) {
            logger.info((Object)"跨服禁止调用beginCross！");
            return;
        }
        try {
            Octets acc;
            logger.info((Object)("CrossManager.beginCross:roleId=" + roleId + "准备开始跨服！"));
            Integer userId = Properties.selectUserid((Long)roleId);
            if (userId == null) {
                logger.error((Object)("CrossManager.beginCross:roleId=" + roleId + "的userId为空！"));
                return;
            }
            Long transferingRole = this.transferingUsers.get(userId);
            if (transferingRole != null) {
                logger.error((Object)("CrossManager.beginCross:roleId=" + roleId + "正在跨服,如果失败,请20秒后再试..."));
                return;
            }
            String ticketstr = Md5Util.encryptToMD5(String.valueOf(System.currentTimeMillis()));
            Octets ticket = new Octets(ticketstr.getBytes("UTF-8"));
            this.userTickets.put(roleId, ticketstr);
            this.transferingUsers.put(userId, roleId);
            SendUserInfoAndTicket snd = new SendUserInfoAndTicket();
            snd.flag = 1;
            snd.ticket = ticket;
            String accstr = Integer.toString(userId);
            snd.account = acc = new Octets(accstr.getBytes("UTF-8"));
            AUUserInfo auInfo = Auuserinfo.select((Integer)userId);
            if (auInfo != null) {
                snd.userinfo.algorithm = auInfo.getAlgorithm();
                snd.userinfo.auth.addAll(auInfo.getAuth());
                snd.userinfo.blisgm = (byte)auInfo.getBlisgm();
                snd.userinfo.func = auInfo.getFunc();
                snd.userinfo.funcparm = auInfo.getFuncparm();
                snd.userinfo.gender = 0;
                snd.userinfo.loginip = auInfo.getLoginip();
                snd.userinfo.nickname = auInfo.getNicknameOctets();
                snd.userinfo.userid = userId;
                DeliveryManager.getInstance().send((Protocol)snd);
            } else {
                logger.error((Object)("CrossManager.beginCross:roleId=" + roleId + ",userId=" + userId + ",AUUserInfo为空！"));
            }
            Executor.getInstance().schedule((Runnable)new CheckCopyDataResultTask(roleId), 29000L, TimeUnit.MILLISECONDS);
        }
        catch (Exception e) {
            logger.error((Object)("CrossManager.beginCross:roleId=" + roleId + "开始跨服发生异常:" + e));
        }
    }

    public void beginSendRoleData(long roleId, CrossTempRole crole) {
        if (this.isInCrossServer()) {
            logger.info((Object)"跨服禁止调用beginSendRoleData！");
            return;
        }
        logger.info((Object)("CrossManager.beginSendRoleData:roleId=" + roleId + "准备开始同步角色数据！"));
        long now = System.currentTimeMillis();
        if (now - crole.getLastcopytime() > Constant.CROSS_COPY_DATA_EXPIRE_TIME || crole.getCopyresult() == 3) {
            crole.setLastcopytime(now);
            crole.getFinishedtable().clear();
            crole.setCopyresult((short)1);
        }
        for (STransferRoleTable transferRoleTable : this.transferRoleTableMap.values()) {
            if (transferRoleTable.tableName == null || transferRoleTable.tableName.trim().equals("")) {
                logger.error((Object)("CrossManager.beginSendRoleData:roleId=" + roleId + "拷贝数据时，表名为空.id=" + transferRoleTable.id));
                return;
            }
            STransferTable transferTable = this.transferTableMap.get(transferRoleTable.tableName.trim());
            if (transferTable == null) {
                logger.error((Object)("CrossManager.beginSendRoleData:roleId=" + roleId + "拷贝数据时，表数据为空.name=" + transferRoleTable.tableName.trim()));
                return;
            }
            Long tableKey = roleId;
            String tableName = transferTable.tableName.trim();
            Octets keyData = OctetsUtil.toOctets((long)roleId);
            Octets valueData = null;
            if (!tableName.equals("xxx")) {
                valueData = TransferDataManager.getInstance().getTableData(tableName, transferTable.valueType.trim(), tableKey);
            }
            SendRoleData snd = new SendRoleData();
            if (valueData == null || keyData == null) {
                snd.roleid = roleId;
                snd.tablename = transferRoleTable.tableName;
                snd.isemptytable = 1;
            } else {
                snd.roleid = roleId;
                snd.tablename = transferRoleTable.tableName;
                snd.isemptytable = 0;
                snd.keydata = keyData;
                snd.valuedata = valueData;
            }
            this.addRelativeData(roleId, transferTable.tableName.trim(), snd, crole.getFlag());
            this.sendToCrossServer(1003, snd);
            int size = 0;
            size += snd.keydata.size();
            size += snd.valuedata.size();
            for (TableData relateData : snd.relationdata) {
                size += relateData.keydata.size();
                size += relateData.valuedata.size();
            }
            logger.info((Object)("CrossManager.beginSendRoleData:发送角色roleId=" + roleId + "的数据表:" + tableName + "成功.总数据大小为:" + size));
        }
    }

    public void notifyClientCross(long roleId) {
        if (this.isInCrossServer()) {
            logger.info((Object)"跨服禁止调用notifyClientCross！");
            return;
        }
        Integer userId = Properties.selectUserid((Long)roleId);
        if (userId == null) {
            return;
        }
        long transferingRole = this.getTransferRoleByUserId(userId);
        if (transferingRole == roleId) {
            this.transferingUsers.remove(userId);
        }
        SBeginCorssServer snd = new SBeginCorssServer();
        String ticket = this.userTickets.remove(roleId);
        if (ticket == null) {
            logger.error((Object)("roleId=" + roleId + " tickety is NULL!"));
            return;
        }
        snd.account = Integer.toString(userId);
        snd.ticket = ticket;
        snd.crossip = crossip;
        snd.crossport = crossport;
        snd.crossnum = crossnum;
        logger.info((Object)("通知客户端account&userid=" + userId + ",roleId=" + roleId + ",ticket=" + ticket + ",可以开始跨服至" + snd.crossip + "," + snd.crossport + "," + snd.crossnum));
        if (Transaction.current() == null) {
            Onlines.getInstance().send(Long.valueOf(roleId), (Protocol)snd);
        } else {
            Procedure.psendWhileCommit((long)roleId, (Protocol)snd);
        }
    }

    private void addRelativeData(long roleId, String tableName, SendRoleData snd, int flag) {
        if (tableName == null) {
            return;
        }
        if (tableName.equals("bag")) {
            ItemMaps bag = Module.getInstance().getItemMaps(roleId, 1, true);
            for (ItemBase basicItem : bag) {
                this.checkAddRelativeData(roleId, basicItem, snd.relationdata);
            }
        } else if (tableName.equals("equip")) {
            ItemMaps bag = Module.getInstance().getItemMaps(roleId, 3, true);
            for (ItemBase basicItem : bag) {
                this.checkAddRelativeData(roleId, basicItem, snd.relationdata);
            }
        } else if (tableName.equals("questbag")) {
            ItemMaps bag = Module.getInstance().getItemMaps(roleId, 5, true);
            for (ItemBase basicItem : bag) {
                this.checkAddRelativeData(roleId, basicItem, snd.relationdata);
            }
        } else if (tableName.equals("petequip")) {
            ItemMaps bag = Module.getInstance().getItemMaps(roleId, 8, true);
            for (ItemBase basicItem : bag) {
                this.checkAddRelativeData(roleId, basicItem, snd.relationdata);
            }
        } else if (tableName.equals("properties")) {
            xbean.Properties properties = Properties.select((Long)roleId);
            if (properties == null) {
                return;
            }
            ArrayList<String> nameStrList = new ArrayList<String>();
            nameStrList.add(properties.getRolename());
            nameStrList.addAll(properties.getUsedname());
            for (String nameStr : nameStrList) {
                snd.relationdata.add(new TableData("rolename2key", OctetsUtil.toOctets((long)roleId), OctetsUtil.toOctets((String)nameStr)));
            }
            if (flag == 0) {
                Position pp = new GridPos(100, 23).toPosition();
                properties.setPosx(pp.getX());
                properties.setPosy(pp.getY());
                properties.setLaststaticsceneid(1711L);
                properties.setSceneid(1711L);
            }
            snd.valuedata = new OctetsStream().marshal((Marshal)properties);
        }
    }

    private void checkAddRelativeData(long roleId, ItemBase basicItem, LinkedList<TableData> relationdata) {
        if (basicItem instanceof EquipItem) {
            EquipItem equipItem = (EquipItem)basicItem;
            long key = equipItem.getDataItem().getExtid();
            Equip equip = Equips.select((Long)key);
            if (equip == null) {
                throw new RuntimeException("角色" + roleId + "拷贝物品道具至跨服服务器时，装备xbean.Equip为空");
            }
            relationdata.add(TransferDataManager.getInstance().genTableData("equips", key, (Bean)equip));
        } else if (basicItem instanceof GroceryItem) {
            EquipItem equipItem = (EquipItem)basicItem;
        } else if (basicItem instanceof TaskItem) {
            EquipItem equipItem = (EquipItem)basicItem;
        } else if (!(basicItem instanceof PetItem) && basicItem instanceof TimeOutItem) {
            TimeOutItem timeOutItem = (TimeOutItem)basicItem;
            ItemBase realBasicItem = timeOutItem.getEffectItem();
            this.checkAddRelativeData(roleId, realBasicItem, relationdata);
        }
    }

    static class SingletonHolder {
        static CrossManager singleton = new CrossManager(null);

        SingletonHolder() {
        }
    }
}

